<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

	<xsl:template match="*" mode="xevLoopFissionC">
		<xsl:param name="split1" />

		<xsl:choose>
			<xsl:when test="self::SgForStatement">
				<xsl:copy>
					<xsl:copy-of select="@*" />
					<xsl:copy-of select="./*[1]" />
					<xsl:copy-of select="./*[2]" />
					<xsl:copy-of select="./*[3]" />
					<SgBasicBlock>
						<!-- <xsl:copy-of select="SgBasicBlock/*[$split1]/preceding-sibling::*" 
							/> -->
						<xsl:apply-templates select="SgBasicBlock/*[position() &lt; $split1]"
							mode="xev_copy_fission" />
					</SgBasicBlock>
					<xsl:copy-of select="PreprocessingInfo" />
				</xsl:copy>
				<xsl:copy>
					<xsl:copy-of select="@*" />
					<xsl:copy-of select="./*[1]" />
					<xsl:copy-of select="./*[2]" />
					<xsl:copy-of select="./*[3]" />
					<SgBasicBlock>
						<!-- <xsl:apply-templates select="SgBasicBlock/*[$split1]/following-sibling::*" 
							mode="xev_copy_fission" /> -->
						<xsl:apply-templates select="SgBasicBlock/*[position() &gt;= $split1]"
							mode="xev_copy_fission" />
					</SgBasicBlock>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<xsl:copy>
					<xsl:copy-of select="@*" />
					<xsl:apply-templates mode="xevLoopFission2">
					</xsl:apply-templates>
				</xsl:copy>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template match="*" mode="xevLoopFission2">
		<xsl:param name="split1" />

		<xsl:choose>
			<xsl:when test="self::SgFortranDo">
				<xsl:copy>
					<xsl:copy-of select="@*" />
					<xsl:copy-of select="./*[1]" />
					<xsl:copy-of select="./*[2]" />
					<xsl:copy-of select="./*[3]" />
					<SgBasicBlock>
						<!-- <xsl:copy-of select="SgBasicBlock/*[$split1]/preceding-sibling::*" 
							/> -->
						<xsl:apply-templates select="SgBasicBlock/*[position() &lt; $split1]"
							mode="xev_copy_fission" />
					</SgBasicBlock>
					<xsl:copy-of select="PreprocessingInfo" />
				</xsl:copy>
				<xsl:copy>
					<xsl:copy-of select="@*" />
					<xsl:copy-of select="./*[1]" />
					<xsl:copy-of select="./*[2]" />
					<xsl:copy-of select="./*[3]" />
					<SgBasicBlock>
						<!-- <xsl:apply-templates select="SgBasicBlock/*[$split1]/following-sibling::*" 
							mode="xev_copy_fission" /> -->
						<xsl:apply-templates select="SgBasicBlock/*[position() &gt;= $split1]"
							mode="xev_copy_fission" />
					</SgBasicBlock>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<xsl:copy>
					<xsl:copy-of select="@*" />
					<xsl:apply-templates mode="xevLoopFission2">
					</xsl:apply-templates>
				</xsl:copy>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template match="*" mode="xevLoopFission">
		<xsl:choose>
			<xsl:when test="self::SgFortranDo">
				<xsl:copy>
					<xsl:copy-of select="@*" />
					<xsl:copy-of select="./*[1]" />
					<xsl:copy-of select="./*[2]" />
					<xsl:copy-of select="./*[3]" />
					<SgBasicBlock>
						<xsl:copy-of
							select="SgBasicBlock/SgPragmaDeclaration/preceding-sibling::*" />
					</SgBasicBlock>
					<xsl:copy-of select="PreprocessingInfo" />
				</xsl:copy>
				<xsl:copy>
					<xsl:copy-of select="@*" />
					<xsl:copy-of select="./*[1]" />
					<xsl:copy-of select="./*[2]" />
					<xsl:copy-of select="./*[3]" />
					<SgBasicBlock>
						<xsl:apply-templates
							select="SgBasicBlock/SgPragmaDeclaration/following-sibling::*"
							mode="xev_copy_fission" />
					</SgBasicBlock>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<xsl:copy>
					<xsl:copy-of select="@*" />
					<xsl:apply-templates mode="xevLoopFission">
					</xsl:apply-templates>
				</xsl:copy>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template match="*" mode="xev_copy_fission">
		<xsl:copy>
			<xsl:copy-of select="@*" />
			<xsl:apply-templates mode="xev_copy_fission" />
		</xsl:copy>
	</xsl:template>
	<xsl:template match="PreprocessingInfo" mode="xev_copy_fission" />

</xsl:stylesheet>
